<digi-typography-heading-jumbo
  af-text="Formulärkomponenter"></digi-typography-heading-jumbo>
<p>&nbsp;</p>
<p>&nbsp;</p>

<digi-form-filter
  afFilterButtonAriaLabel="Välj yrkesområden. När listan expanderats kan du navigera mellan alternativen med piltangenterna"
  afFilterButtonText="Yrkesområde"
  afSubmitButtonText="Filtrera"
  [afListItems]="[{ id: 'omr1', label: 'Område 1' }]"
  (afSubmitFilter)="handleSubmitFilter($event.detail)"
  (afCloseFilter)="handleCloseFilter($event.detail)"
  (afChangeFilter)="handleChangeFilter($event.detail)"
  (afResetFilter)="handleResetFilter()"></digi-form-filter>

<!-- <digi-form-filter
  af-filter-button-aria-label="Välj yrkesområden. När listan expanderats kan du navigera mellan alternativen med piltangenterna"
  af-filter-button-text="Yrkesområde"
  af-submit-button-text="Filtrera"
  af-submit-button-text-aria-label="Applicera valda yrkesområden"
  af-reset-button-text="Rensa allt"
  af-reset-button-text-aria-label="Rensar alla valda alternativ"
  af-hide-reset-button="true"
  (afOnSubmitFilters)="testFilterSubmited($event)"
  (afOnFilterClosed)="testFilterClosed($event)"
  >
  <ng-container *ngIf="showCheckboxList1; else checkboxList2Template">
  <digi-form-checkbox af-label="Val 1" af-id="val11" af-value="val11"></digi-form-checkbox>
  <digi-form-checkbox af-label="Val 2" af-id="val12" af-value="val12"></digi-form-checkbox>
  <digi-form-checkbox af-label="Val 3" af-id="val13" af-value="val13"></digi-form-checkbox>
  </ng-container>
  </digi-form-filter> -->

<!-- <ng-template #checkboxList2Template>
  <digi-form-checkbox af-label="Val 4" af-id="val11"></digi-form-checkbox>
  <digi-form-checkbox af-label="Val 5" af-id="val12"></digi-form-checkbox>
  <digi-form-checkbox af-label="Val 6" af-id="val13"></digi-form-checkbox>
  <digi-form-checkbox af-label="Val 7" af-id="val14"></digi-form-checkbox>
  <digi-form-checkbox af-label="Val 8" af-id="val15"></digi-form-checkbox>
  <digi-form-checkbox af-label="Val 9" af-id="val16"></digi-form-checkbox>
  </ng-template>
  <digi-button (afOnClick)="debugHandler()"
  >DEBUG</digi-button
  > -->

<div *ngIf="showErrorList">
  <digi-form-error-list
    class="error-list"
    af-heading="Felmeddelanden"
    af-id="errorsList"
    af-override-link="true"
    [ngStyle]="{
      'margin-bottom': 'var(--digi--padding--large)',
      display: 'block'
    }">
    <ng-container *ngFor="let error of formErrorList">
      <a [attr.href]="'#' + error.id" *ngIf="!error.valid">{{
        error.message
      }}</a>
    </ng-container>
  </digi-form-error-list>
</div>

<form [formGroup]="myForm" class="my-form" id="myForm">
  <div class="form-values">
    <p>myForm.value: {{ myForm.value | json }}</p>
  </div>

  <digi-calendar-datepicker
    af-id="mySelectedDate"
    af-name="mySelectedDate"
    formArrayName="mySelectedDate"
    (afOnDateChange)="onDateChange($event)">
  </digi-calendar-datepicker>

  <div style="margin: 10px auto">
    <h3>Multipla datum</h3>
    <digi-calendar-datepicker
      af-id="myMultipleDates"
      af-name="myMultipleDates"
      formArrayName="myMultipleDates"
      afMultipleDates="true"
      (afOnDateChange)="onMultipleDateChange($event)">
    </digi-calendar-datepicker>
  </div>

  <digi-form-file-upload
    af-id="myFileUpload"
    af-variation="primary"
    af-label="Ladda upp fil (en åt gången) "
    af-label-description="Virussökning aktiv, max antal filer 5, största filstorlek 3MB"
    af-file-max-size="3"
    af-max-files="5"
    af-name="angular-test-file-upload"
    af-heading-files="test"
    af-file-types="image/png"
    (afOnUploadFile)="onUpload($event)"
    (afOnRemoveFile)="onRemove($event)"
    (afOnCancelFile)="onCancel($event)"
    (onAfOnRetryFile)="onRetry($event)"></digi-form-file-upload>

  <digi-form-input
    af-id="myName"
    af-name="myName"
    af-label="Namn"
    af-required="true"
    af-autocomplete="off"
    [attr.af-validation]="
      myForm.controls['myName'].invalid | formcontrolInvalid: submitted
    "
    [attr.af-validation-text]="getValidationText('myName')"
    [attr.af-value]="myForm.controls['myName'].value"
    formControlName="myName"></digi-form-input>

  <digi-form-input
    af-id="myEmail"
    af-name="myEmail"
    af-label="Epost-adress"
    [afType]="FormInputType.EMAIL"
    af-autocomplete="off"
    [attr.af-validation]="
      myForm.controls['myEmail'].invalid | formcontrolInvalid: submitted
    "
    [attr.af-validation-text]="getValidationText('myEmail')"
    [attr.af-value]="myForm.controls['myEmail'].value"
    formControlName="myEmail"></digi-form-input>
  <br />
  <div>
    <digi-form-select-filter
      formControlName="mySelectedLanguages"
      [attr.af-filter-button-text-label]="'Välj språk'"
      [attr.af-description]="'Beskrivande text'"
      [attr.af-filter-button-text]="'Inget språk valt'"
      [attr.af-submit-button-text]="'Filtrera'"
      [attr.af-multiple-items]="true"
      [afListItems]="_selectFilterListItems"
      (afOnSubmitFilters)="setClosed($event)"
      (afOnQueryChanged)="setClosed($event)">
    </digi-form-select-filter>
  </div>
  <br />
  <digi-form-select
    af-id="myRole"
    af-name="myRole"
    af-label="Roll"
    af-required="true"
    af-placeholder="Välj roll"
    [attr.af-validation]="
      myForm.controls['myRole'].invalid | formcontrolInvalid: submitted
    "
    formControlName="myRole">
    <ng-container *ngFor="let selectItem of selectItems">
      <option [attr.value]="selectItem.value">{{ selectItem.name }}</option>
    </ng-container>
  </digi-form-select>

  <digi-form-textarea
    af-id="myDescription"
    af-name="myDescription"
    af-label="Beskriv dig själv"
    af-required="true"
    [attr.af-validation]="
      myForm.controls['myDescription'].valid && submitted
        ? FormTextareaValidation.SUCCESS
        : (myForm.controls['myDescription'].invalid
          | formcontrolInvalid: submitted)
    "
    [attr.af-validation-text]="getValidationText('myDescription')"
    [attr.af-value]="myForm.controls['myDescription'].value"
    formControlName="myDescription"></digi-form-textarea>

  <digi-button (afOnClick)="showRadioGroup = !showRadioGroup"
    >Toggle radiobuttons</digi-button
  >
  <p>Testa av hur värdena ändras mellan sidbyten/toggles</p>

  <div *ngIf="showRadioGroup">
    <digi-form-fieldset af-legend="Erfarenhet" class="form-fieldset">
      <digi-form-radiogroup
        id="myExperience"
        tabindex="-1"
        formControlName="myExperience">
        <digi-form-radiobutton
          class="form-radiobutton"
          af-label="0-2 år"
          af-value="0-2"></digi-form-radiobutton>
        <digi-form-radiobutton
          class="form-radiobutton"
          af-label="2-5 år"
          af-value="2-5"></digi-form-radiobutton>
        <digi-form-radiobutton
          class="form-radiobutton"
          af-label="5 år och mer"
          af-value="5"></digi-form-radiobutton>
      </digi-form-radiogroup>
    </digi-form-fieldset>
  </div>

  <hr />

  <p>{{ myAds.value | json }}, {{ myAds.value.length }}</p>

  <digi-form-fieldset
    af-legend="Ads (test av indeterminate)"
    class="form-fieldset"
    formArrayName="myAds"
    id="myAds"
    tabindex="-1">
    <digi-form-checkbox
      [attr.af-label]="'Välj alla annonser'"
      (change)="onCheckClick($event)"
      [attr.af-indeterminate]="myAds.value.length > 0 && myAds.value.length < 2"
      [attr.af-checked]="myAds.value.length > 0"
      [checked]="myAds.value.length === 2"></digi-form-checkbox>

    <ng-container *ngFor="let ad of adsList">
      <digi-form-checkbox
        class="form-checkbox"
        (afOnChange)="optionAddChange($event)"
        [attr.af-label]="ad.text"></digi-form-checkbox>
    </ng-container>
  </digi-form-fieldset>

  <hr />

  <digi-form-fieldset
    af-legend="Jag har erfarenhet inom"
    class="form-fieldset"
    formArrayName="myOptionalSkills"
    id="myOptionalSkills"
    tabindex="-1">
    <ng-container *ngFor="let skill of optionalSkills">
      <digi-form-checkbox
        class="form-checkbox"
        (afOnChange)="optionSkillChange($event)"
        [attr.af-label]="skill.text"
        [attr.af-value]="skill.val"></digi-form-checkbox>
    </ng-container>
  </digi-form-fieldset>

  <digi-form-fieldset af-legend="Kompetenser">
    <ng-container formArrayName="mySkills">
      <ng-container *ngFor="let skillForm of mySkills.controls; let i = index">
        <!-- changed to formGroupName /Sean: https://www.digitalocean.com/community/tutorials/angular-reactive-forms-formarray-dynamic-fields#:%7E:text=FormArray%20is%20used%20to%20track,or%20even%20other%20FormArray%20instances.-->
        <div [formGroupName]="i" class="skill-form-row">
          <digi-form-input
            [afId]="'mySkillTitle' + i"
            af-name="mySkillTitle"
            af-label="Kompetens"
            [afType]="FormInputType.TEXT"
            formControlName="mySkillTitle"></digi-form-input>
          <digi-form-input
            [afId]="'mySkillLevel' + i"
            af-name="mySkillLevel"
            af-label="Nivå (0-3)"
            [attr.af-min]="0"
            [attr.af-max]="3"
            [afType]="FormInputType.NUMBER"
            formControlName="mySkillLevel"></digi-form-input>
          <digi-button af-variation="secondary" (afOnClick)="removeSkill(i)"
            >Ta bort</digi-button
          >
        </div>
      </ng-container>
    </ng-container>
    <digi-button af-variation="secondary" (afOnClick)="addSkill()"
      >Lägg till kompetens</digi-button
    >
  </digi-form-fieldset>

  <div class="submit-wrapper">
    <digi-button (afOnClick)="submitButtonHandler()"
      >Skicka in ansökan</digi-button
    >
  </div>
</form>
